diff -urN versao_6D/stoqdrivers-0.9.11/stoqdrivers/serialbase.py trunk/stoqdrivers/serialbase.py
--- versao_6D/stoqdrivers-0.9.11/stoqdrivers/serialbase.py	2016-12-29 14:30:59.000000000 -0200
+++ trunk/stoqdrivers/serialbase.py	2016-10-13 16:22:19.188315288 -0300
@@ -25,39 +25,49 @@
 ##              Henrique Romano  <henrique@async.com.br>
 ##
 
-from kiwi.log import Logger
 from serial import Serial, EIGHTBITS, PARITY_NONE, STOPBITS_ONE
 from zope.interface import implements
 
 from stoqdrivers.interfaces import ISerialPort
+from stoqdrivers.exceptions import CommError
+from sigpdv.tools.log import traced
 
-log = Logger('stoqdrivers.serial')
 
 class VirtualPort:
     implements(ISerialPort)
 
+    @traced
     def getDSR(self):
         return True
 
+    @traced
     def setDTR(self, value):
         pass
 
+    @traced
     def set_options(self, baudrate=9600, bytesize=EIGHTBITS, parity=PARITY_NONE,
-                    stopbits=STOPBITS_ONE, read_timeout=3, write_timeout=0):
+                    stopbits=STOPBITS_ONE, read_timeout=1, write_timeout=1):
         pass
 
+    @traced
     def write(self, data):
         pass
 
+    @traced
     def read(self, n_bytes=1):
         return ''
 
+
 class SerialPort(Serial):
     implements(ISerialPort)
 
     def __init__(self, device):
         Serial.__init__(self, device)
-        self.setDTR(True)
+#        self.setDTR(True)
+        try:
+            self.setDTR(True)
+        except:
+            pass
         self.flushInput()
         self.flushOutput()
         self.set_options()
@@ -66,8 +76,9 @@
     # this to work. Maybe we should change this and do all the driver specify
     # its options, but right now I think that's ok, since these options are
     # common to most of the drivers.
+    @traced
     def set_options(self, baudrate=9600, bytesize=EIGHTBITS, parity=PARITY_NONE,
-                    stopbits=STOPBITS_ONE, read_timeout=3, write_timeout=0):
+                    stopbits=STOPBITS_ONE, read_timeout=1, write_timeout=1):
         self.setBaudrate(baudrate)
         self.setByteSize(bytesize)
         self.setParity(parity)
@@ -75,6 +86,10 @@
         self.setTimeout(read_timeout)
         self.setWriteTimeout(write_timeout)
 
+    @traced
+    def open(self):
+        return super(SerialPort, self).open()
+
 class SerialBase(object):
 
     # All commands will have this prefixed
@@ -87,31 +102,51 @@
     def __init__(self, port):
         self._port = port
 
+    @traced
     def set_port(self, port):
         self._port = port
 
+    @traced
     def get_port(self):
         return self._port
 
+    @traced
     def fileno(self):
         return self._port.fileno()
 
-    def writeline(self, data):
+    @traced
+    def writeline(self, data, retries=10):
         self.write(self.CMD_PREFIX + data + self.CMD_SUFFIX)
-        return self.readline()
+        read = self.readline(retries=retries)
+        return read
 
+    @traced
     def write(self, data):
-        log.debug(">>> %r (%d bytes)" % (data, len(data)))
-        self._port.write(data)
+        while True: # Limpar buffer antes de enviar comando
+            c = self._port.read(0)
+            if not c:
+                break
+        return self._port.write(data)
 
+    @traced
     def read(self, n_bytes):
         return self._port.read(n_bytes)
 
-    def readline(self):
+    @traced
+    def readline(self, retries=10):
         out = ''
+        a = 0
+        retries = retries
         while True:
+            if a > retries:
+                raise CommError("Timeout")
+
             c = self._port.read(1)
+            if not c:
+                a += 1
+                continue
+            a = 0
+
             if c == self.EOL_DELIMIT:
-                log.debug('<<< %r' % out)
                 return out
-            out += c
+            out += c
\ Falta o caracter nova linha no final do arquivo
